.include "Player.h.s"


.area _DATA
    auxDW: .dw #0xFFFF
    object_grab::   .db #0
    timer:          .db #5
    timerM:         .db #8
    lifes::         .db #9                            ;Las vidas del jugador en cuanto se acaben se acaba la partida y lo manda al inicio
    lvl_completed::  .db #0x00                             ;Contabilizamos el numero de niveles que ha pasado el jugador para comunicarselo al jugador 
                                                        ; si pierde la partida
    .globl PlayerSprite                                 
    .globl physics_grab
    .globl render_change_screen
    .globl man_gameover_init
   
.globl entity_array
.area _CODE

player_get_input::

    ld hl, #key_pressingX
    call entity_forfirst

    ld hl, #key_pressingY
    call entity_forfirst

    ld hl, #key_pressing_action
    call entity_forfirst

    

ret


key_pressingX::           
    ex de, hl
    ld (auxDW), hl

    ld bc, (auxDW)
    ld   ix, #0x000
    add  ix, bc 

    ; call cpct_scanKeyboard_asm            ;; DESTROY AF, BC, DE, HL  !!!!!!!!!!
    ld a,#0x00
      ;; (2B HL) key	
    ld hl, #Key_P
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr z, noKeyDPressed        ;;key D is not pressed

   joy_right:

    ld +3(ix), #0x01
    ld a, #1
    ld (physics_player_last_velX),a

    ld hl, #PlayerSprite
     ld (auxDW), hl

    ld bc, (auxDW)
    ld   ix, #0x000
    add  ix, bc 
    ;; .db     #0x06 , #0x60
    ld  +18(ix), #0x06
    ld  +19(ix), #0x60
    jr finishX

   noKeyDPressed:

    ;;CONTROLES PARA EL JOYSTICK;;;;;

      ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr nz, joy_right      ;;Joystick right is not pressed
   
   ld +3(ix), #0x00
   
    

   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ld a,#0x00
    ld hl, #Key_O
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL


    cp #0
    jr z, noKeyAPressed        ;;key A is not pressed

    joy_left:
   
   
    ld +3(ix), #0xFF

    ld a, #0xFF
    ld (physics_player_last_velX),a


    ld hl, #PlayerSprite
     ld (auxDW), hl

    ld bc, (auxDW)
    ld   ix, #0x000
    add  ix, bc 
    ;; .db     #0x06 , #0x60
    ld  +22(ix), #0x60
    ld  +23(ix), #0x06
    
    jr finishX
    

   noKeyAPressed:


      ;;CONTROLES PARA EL JOYSTICK;;;;;

      ld hl, #Joy0_Left
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr nz, joy_left        ;;Joystick left is not pressed
   
   ld +3(ix), #0x00
   
    finishX:
   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
ret         ;;  DESTROY AF, BC, DE, HL, IX !!!!!!!!!!


key_pressingY::           
    ex de, hl
    ld (auxDW), hl

    ld bc, (auxDW)
    ld   ix, #0x000
    add  ix, bc 

    ;call cpct_scanKeyboard_asm            ;; DESTROY AF, BC, DE, HL  !!!!!!!!!!
   
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr z, noKeyWPressed        ;;key W is not pressed

    joy_jump:


    call physics_start_jumping
    ;ld +4(ix), #0xF7
    jr finish

   noKeyWPressed:

     ;;CONTROLES PARA EL JOYSTICK;;;;;

      ld hl, #Joy0_Fire1
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr nz, joy_jump        ;;Joystick fire 1 is not pressed

  
   ;ld +4(ix), #0x00



   
   finish:
ret         ;;  DESTROY AF, BC, DE, HL, IX !!!!!!!!!!


key_pressing_action:: 
    ld a, (timer)
    cp #0
    jr nz, timerStop
    ex de, hl
    ld (auxDW), hl

    ld bc, (auxDW)
    ld   ix, #0x000
    add  ix, bc 

    ;call cpct_scanKeyboard_asm            ;; DESTROY AF, BC, DE, HL  !!!!!!!!!!
   
    ld hl, #Key_Space
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr z, noKeyWPressedSpace        ;;key W is not pressed

   
    joy_take:

    ld a, (object_grab)         ;; check if have and object grabed or not

    call physics_grab

    ld a, #8
    ld (timer),a
    

   noKeyWPressedSpace:

      ;;CONTROLES PARA EL JOYSTICK;;;;;

      ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr nz, joy_take     ;;Joystick fire 2 is not pressed


   ld hl, #Key_R
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr z, noKeyRPressed        ;;key W is not pressed
     
    ld a, #1
    ld hl , #lifes                  ;;Primero comprobamos si el player ha gastado todas sus vidas
    cp (hl)
    call z , man_gameover_init      ;;Si ha perdido todas las vidas nos vamos a la pantalla de gameover
   
    dec (hl)
   
    call load_level
    ret


   noKeyRPressed:
  
   ld hl, #Key_N
    call cpct_isKeyPressed_asm        ;; Destroyed Register values
                                        ;;A, D, BC, HL

    cp #0
    jr z, noKeyNPressed        ;;key W is not pressed
   
    ld c, #1
   
    ;UNCOMMENT TO ENABLE CHEAT MODE
    ;call load_next_level
    ret
    

   noKeyNPressed:
;
    ;------------------------------------------------------------------------
    ld a, (timer)
    cp #0
    jr z, timeractive
    timerStop:
    ld hl, #timer
    dec (hl)
    timeractive:

ret         ;;  DESTROY AF, BC, DE, HL, IX !!!!!!!!!!

player_set_life_9:
    ld a, #9
    ld (lifes), a
ret

player_add_life: ;en c, la cantidad de vidas a subir
    ld a, (lifes)
    cp #9
    ret z

    add c
    ld (lifes), a

    cp #9
    call nc, player_set_life_9

ret


key_pressing_M::

    ld a, (timerM)
    cp #0
    jr nz, timerStopM

    ld hl, #Key_M
    call cpct_isKeyPressed_asm

    cp #0
    jr z, noPulsandoM

    pulsandoM:
    ld a, #20
    ld (timerM),a

    ld a, (muted)
    cp #0
    jp z, sound_mute
    jp nz, sound_unmute

    

    noPulsandoM:

    ld a, (timerM)
    cp #0
    jr z, timerMactive
    timerStopM:
    ld hl, #timerM
    dec (hl)
    timerMactive:
ret

sound_mute:
    ld a, #1
    ld (muted), a

    call cpct_akp_stop_asm
ret

sound_unmute:
    ld a, #0
    ld (muted), a
ret

