;;;;;;;;;;;;;;;;;;;;;;;;;;;; LICENSE ;;;;;;;;;;;;;;;;;;;;;;;
;  This file has been made for VandalBox, a videogame for Amstrad CPC
;  Copyright (C) 2020 
;  Made by VandalVermiaDIK (Vladislav Kurnosov, Damián Llorente and Martín Illán) 
;
;  VandalBox is free software. It can be used, redistributed, changed,
;  and distributed after being changed. This must be done according to
;  the GNU GPL license provided with the software 
;  (VandalBox/Source Code/GPL-LICENSE.txt) 
;
;  This software offers no warranties, not even the 'merchantability' or
;  'fitness for a particular cause'. The developers cannot be held
;  accountable for the use that third parties may make of it. Please
;  refer to the license document (VandalBox/Source Code/GPL-LICENSE.txt)
;  for further information.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "cpctelera.h.s"
.include "man/menu.h.s"

.area _DATA
.globl flags
   flags: .db #0x01
   int_aux: .db #6
   .globl cpct_setPALColour_asm


.globl insert_tips
.globl main_gameloop
.globl cpct_disableFirmware_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSprite_asm
.globl cpct_drawSolidBox_asm
.globl cpct_waitVSYNC_asm
.globl cpct_scanKeyboard_asm  
.globl cpct_isKeyPressed_asm
.globl anim_check_change
.globl lvl_completed
.globl anim_init

.globl muted
.globl render_init
.globl render_one_entity
.globl render_erase_one_entity
.globl render_estatico
.globl render_all_entities
.globl render_video_to_sub
.globl render_change_screen
.globl render_heart

.globl player_get_input

;.globl entity_create
.globl entity_forall
;.globl entity_array
.globl entity_forfirst
.globl entity_create_player
.globl entity_create_box

.globl entity_create_turret
.globl entity_create_missile

.globl entity_create_platform
.globl entity_create_wall
.globl entity_create_finish
.globl entity_create_horizontal_ladder

.globl entity_forall_but_first

.globl key_pressingX
.globl key_pressingY
.globl key_pressing_action

.globl _clear_screen

.globl load_next_level
.globl key_pressing_M


.globl physics_update_one_entity
.globl physics_move_box_with_player
.globl physics_update_all_entities
.globl entity_create_spikes

.globl physics_player_reset
.globl obj_turret_shoot
.globl obj_turret_destroy_shoot
.globl cpct_scanKeyboard_asm


.globl entity_colision

.globl cpct_akp_musicPlay_asm
.globl cpct_akp_musicInit_asm
.globl _sound

reload_missile:: .db #0x00
.area _CODE

;;.dsad
int_handler::
   push af
   push hl
   push de
   push bc
   
   ld a, (int_aux)
   dec a
   jr nz, cont
   call cpct_scanKeyboard_asm
   call key_pressing_M

   ld a, (muted)
   cp #0
   jr nz, esta_muteado
   call cpct_akp_musicPlay_asm
   
   esta_muteado:
   ld a, #6
   cont:
   ld (int_aux), a

   ;ld h, a 
   ;ld l, #16
   ;call cpct_setPALColour_asm

   
    pop bc
    pop de
    pop hl
    pop af

   ei

reti

set_int_handler:
   call cpct_waitVSYNC_asm
   halt 
   halt
   call cpct_waitVSYNC_asm

   ld hl, #0x38
   ld (hl), #0xc3
   inc hl
   ld (hl), #<int_handler
   inc hl
   ld (hl),#>int_handler
   inc hl
   ld (hl), #0xc9

ret

;reset_all_entities::
;   ld hl, #reset_x_speed
;   call entity_forall
;
;   
;ret

suma_iteracion::

   ld hl , #reload_missile
   inc (hl)


ret




_clear_screen::
   call _clear_screen_main
   call _clear_screen_sub
ret

_clear_screen_main:
   ld hl, #0xc000
   ld (hl), #0
   ld de, #0xc001
   ld bc, #0x3fff
   ldir
ret

_clear_screen_sub:
   ld hl, #0x8000
   ld (hl), #0
   ld de, #0x8001
   ld bc, #0x3fff
   ldir
ret


wait_halts:
   ld c, #6
   haltloop:
      halt
      dec c 
      jr nz, haltloop
ret




_main::
   ;call cpct_disableFirmware_asm
   call set_int_handler
   ld sp, #0x7fff
   ;; SONIDO
   ld de, #_sound
   call cpct_akp_musicInit_asm
   
   ;Set video things
	call render_init		
   call _clear_screen
   
empieza_juego::
   
   ;;INIT DEL MENU Y RUN;;
   call man_menu_init
   call man_menu_run

   ;;LIMPIAMOS LA PANTALLA;

   call _clear_screen


   

   call load_next_level
   call render_estatico
   main_gameloop:

      call player_get_input   ;Leer teclas
     
      call physics_player_reset
      call physics_update_all_entities ;Update de físicas (movimiento, colisiones, etc)

      call anim_check_change
      ;call insert_tips
       
      call render_all_entities   ;Dibujar en pantalla

      call suma_iteracion

      ;ld hl , #obj_turret_destroy_shoot
      ;call entity_forall_but_first

      call render_change_screen
     
jr main_gameloop

nothing:

ret