.include "levels.h.s"

.globl entity_create_turret
.globl lvl_completed
.globl str_GODecimal
.globl cpct_setDrawCharM1_asm
.globl cpct_drawStringM1_asm
.globl render_video_to_main
.globl render_video_to_sub



.area _DATA
    current_level::         .db #0x00
    cuenta::                .db #0xFF
    str_arrow_down:         .asciz "v"
    str_arrow_stick1:       .asciz "|"
    str_arrow_stick2:       .asciz "__"
    str_arrow_right:        .asciz ">"
    str_jump:               .asciz "JUMP"
    str_fall:               .asciz "FALL"
    str_double_jump_M:      .asciz "Reset jump"

.area _CODE



load_next_level:
    ld c, #1
     call player_add_life

    ld a, #70
    ld (contadordepintar),a
    ld a , (lvl_completed)
    cp #10
    jr z , reinicia

    ld hl , #lvl_completed
    inc (hl)
    daa                          ;;Este comando se encarga de convertir el acarreo hexadecimal en decimal . 
                                  ;Es decir en vez de pasar de 9 a A  ; se pasa de 9 a 0 sumando uno al termino anterior
   
    
    ld hl, #current_level
    inc (hl)

    ld hl , #cuenta
    inc (hl)
    jp load_level

    reinicia:

    	ld hl , #lvl_completed
	    ld (hl) , #1 

        	ld hl , #str_GODecimal
            inc (hl)

        

     ld hl, #current_level
    inc (hl)


    ld hl , #cuenta
    inc (hl)
    jp load_level


load_level: ;en a, el nivel a cargar
    ld a, #70
    ld (contadordepintar),a
    call entity_borra_array
    call _clear_screen
    
    ld a, (current_level)

    cp #0
    ret z

    cp #1
    jp z, load_level_monke

    cp #2
    jp z, load_level_inicio

    cp #3
    jp z, load_level_zigzag

    cp #4
    jp z, load_level_apilar

    cp #5
    jp z, load_level_intropinchos

    cp #6
    jp z, load_level_pinchos

    cp #7
    jp z, load_level_cajapinchos
   
    cp #8
    jp z, load_level_caida_y_salto1

    cp #9
    jp z, load_level_caida_y_salto2

    cp #10
    jp z, load_level_intro_bolita

    cp #11
    jp z, load_level_doble_bolita2

     cp #12
    jp z, load_level_puente

    cp #13
    jp z, load_level_cajabolita

    cp #14
    jp z, load_level_cajabolita2

    cp #15
    jp z, load_level_introtorreta

    cp #16
    jp z , load_level_torreta2

    cp #17
    jp z, load_level_slalom

    cp #18
    jp z, load_level_torretbolitas

    cp #19
    jp z, load_level_turretcorridor

    cp #20
    jp z, load_level_ladder1

    cp #21
    jp z, load_level_ladder2

    cp #22 
    jp z, load_level_ladderturret

    cp #23
    jp z, load_level_heaven

    cp #24
    jp z, load_level_hell

    cp #25
    jp z, load_level_final
    

    ;Si no es ninguno, nos hemos pasado, asi que reseteamos
    ld a, #0
    ld (current_level), a
    jp physics_finish
ret


;;PARA CREAR NIVELES:
;;;;;; PRIMERO PINCHOS
;;;;;; SEGUNDO PLATAFORMAS
;;;;;; DESPUES MUROS
;;;;;; DESPUES TORRETAS
;;;;;; Y POR ULTIMO CAJAS




load_level_torreta2:


ld b , #45
ld c , #160

call entity_create_player


;;Plataformas;;;;;;;;;;;;;;;;;;

   ld b , #45
   ld c , #145
   call entity_create_platform



   ld b , #78
   ld c , #160
   call entity_create_platform

      ld b , #11
   ld c , #165
   call entity_create_platform



     ld b , #30
   ld c , #120
   call entity_create_platform



    ld b , #10
   ld c , #100
   call entity_create_platform


   ld b , #30
   ld c , #75
   call entity_create_platform



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,



;;Doble Salto;;;;;;;;;;;;;;;;;;;;;;;;;



    ld b , #20
   ld c , #130
   call entity_create_doublejump


     ld b , #20
   ld c , #40
   call entity_create_doublejump






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Torretas


  ld b, #78
    ld c, #90
    call entity_create_turret

      
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    

;;Pinchos;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ld b , #0
    ld c, #196
    call entity_create_spikes

     ld b , #7
    ld c, #196
    call entity_create_spikes

     ld b , #14
    ld c, #196
    call entity_create_spikes

     ld b , #21
    ld c, #196
    call entity_create_spikes

     ld b , #28
    ld c, #196
    call entity_create_spikes
    

     ld b , #35
    ld c, #196
    call entity_create_spikes

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Puerta al siguiente nivel 


   ld b , #0
   ld c , #50
   call entity_create_platform

   ld b , #0
   ld c , #40

   call entity_create_finish


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


 jp level_finish_loading


ret

;;Funcion de dibujar los tips del nivel 6


insert_tips::


;;INSERTAR CONSEJOS NIVEL 7;;;;;;;;;;;
    ld a ,(current_level)
    cp #8
    call z , insert_tips_level8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;INSERTAR CONSEJOS NIVEL 10;;;;;;;;;;;;

     ld a ,(current_level)
    cp #10
    call z , insert_tips_level10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ret

insert_tips_level8::

;;MENSAJE FALL;;;;;;;;
    ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_fall
	X = 45
	Y = 20
	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_fall

	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm


    ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_arrow_stick1
	X = 16
	Y = 40
	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_arrow_stick1

	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    
   
     ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_arrow_down
	X = 16
	Y = 47

	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_arrow_down
	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;MENSAJE JUMP;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_jump
	X = 46
	Y = 100
	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_jump

	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm


    ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_arrow_stick2
	X = 63
	Y = 108
	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_arrow_stick2

	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    
   
     ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_arrow_right
	X = 19
	Y = 120

	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_arrow_right
	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ret


insert_tips_level10::

;;MENSAJE DOBLE SALTO;;;;;;;;
    ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_double_jump_M
	X = 67
	Y = 100
	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_double_jump_M

	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm


    ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_arrow_stick1
	X = 45
	Y = 120
	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_arrow_stick1

	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    
   
     ld  de,  #0x0001
	call cpct_setDrawCharM1_asm
	ld  iy,  #str_arrow_down
	X = 61
	Y = 130

	ld  hl,  #0xC000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

    ld  iy,  #str_arrow_down
	ld  hl,  #0x8000 + 64 * (Y/8) + 2048 * (Y&7) + X
	call cpct_drawStringM1_asm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



ret



load_level_doble_bolita2:


ld b , #80
ld c , #160

call entity_create_player


;;Plataformas;;;;;;;;;;;

    ld b , #80
   ld c , #170

   call entity_create_platform


     ld b , #40
   ld c , #150

   call entity_create_platform

    ld b , #10
   ld c , #130

   call entity_create_platform

   ld b , #50
   ld c , #110

   call entity_create_platform

     ld b , #60
   ld c , #70

   call entity_create_platform

   ld b , #20
   ld c , #60

   call entity_create_platform



;;;;;;;;;;;;;;;;;;;;;;;;


;;Doble Salto;;;;;;;;;;;;;;


    ld b , #60
   ld c , #130

   call entity_create_doublejump

    
    ld b , #30
   ld c , #110

   call entity_create_doublejump

    ld b , #35
   ld c , #90

   call entity_create_doublejump

   ld b , #50
   ld c , #70

   call entity_create_doublejump

    ld b , #40
   ld c , #50

   call entity_create_doublejump

    


;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;Pinchos;;;;;;;;;;;;;;;;;;;;;




    ld b ,#0
    ld c , #196

    call entity_create_longspikes

     ld b ,#19
    ld c , #196

    call entity_create_longspikes
     ld b ,#38
    ld c , #196

    call entity_create_longspikes

     ld b ,#57
    ld c , #196

    call entity_create_longspikes



;;;;;;;;;;;;;;;;;;;;;;;;;;


;;Puerta al siguiente nivel 


   ld b , #0
   ld c , #50
   call entity_create_platform

   ld b , #0
   ld c , #40

   call entity_create_finish


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


 jp level_finish_loading

ret



load_level_intro_bolita:


    call insert_tips_level10                    ;;Inserta los consejos


    ld b , #0
    ld c , #90
    call entity_create_player

;;Primera plataforma;;;;;;;

    ld b , #0
    ld c , #140
    call entity_create_platform

    ld b , #10
    ld c , #140
    call entity_create_platform

    ld b , #20
    ld c , #140
    call entity_create_platform

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Doble Salto;;;;;;


    ld b , #45
    ld c , #120
    call entity_create_doublejump

;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Pinchos;;;;;;;;;;;;;;;;;;;;;;;




    ld b ,#0
    ld c , #196

    call entity_create_spikes

     ld b ,#7
    ld c , #196

    call entity_create_spikes
     ld b ,#14
    ld c , #196

    call entity_create_spikes

     ld b ,#21
    ld c , #196

    call entity_create_spikes


     ld b ,#28
    ld c , #196

    call entity_create_spikes



     ld b ,#35
    ld c , #196

    call entity_create_spikes


     ld b ,#42
    ld c , #196

    call entity_create_spikes

     ld b ,#49
    ld c , #196

    call entity_create_spikes

     ld b ,#56
    ld c , #196

    call entity_create_spikes

      ld b ,#63
    ld c , #196

    call entity_create_spikes

      ld b ,#70
    ld c , #196

    call entity_create_spikes


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Puerta al siguiente nivel 

    ld  b, #60
   ld c, #140
   call entity_create_platform

    ld  b, #70
   ld c, #140
   call entity_create_platform

   ld b , #80
   ld c , #130

   call entity_create_finish


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


   jp level_finish_loading



ret


load_level_caida_y_salto2:


  ld b, #1
    ld c, #140
    call entity_create_player

    

;;Plataforma de inicio

    ld b, #0
   ld c, #150
   call entity_create_platform


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;Pinchos del suelo;;;;;;;;;;;;;;;


    ld b ,#0
    ld c , #196

    call entity_create_longspikes

     ld b ,#19
    ld c , #196

    call entity_create_longspikes
     ld b ,#38
    ld c , #196

    call entity_create_longspikes

     ld b ,#57
    ld c , #196

    call entity_create_longspikes

   


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;;Plataformas de avance 1;;;;;;;;;;;


     ld  b, #10
   ld c, #130
   call entity_create_platform


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;Muro;;;;;;;;;;;;;;;;;;;;;;;;;;;;




    ld  b, #28
   ld c, #15
   call entity_create_longwall

  
  
   ld  b, #28
   ld c, #55
   call entity_create_longwall

    ld  b, #28
   ld c, #95
   call entity_create_longwall
    ld b, #28
   ld c, #95+40-2
   call entity_create_lid


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;Plataformas de avance 2;;;;;;;;;;;;


   ld  b, #38
   ld c, #165
   call entity_create_platform

   ld  b, #65
   ld c, #150
   call entity_create_platform

    ld  b, #58
   ld c, #120
   call entity_create_platform



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Puerta al siguiente nivel 

    ld  b, #31
   ld c, #110
   call entity_create_platform

   ld b , #31
   ld c , #100

   call entity_create_finish


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


   jp level_finish_loading



ret

load_level_monke:
   ld b, #1
   ld c, #170
   call entity_create_player

   ld b , #71
   ld c , #140
   call entity_create_finish

   ld b, #28
   ld c, #171
   call entity_create_longplatform

   ld b, #40
   ld c, #171
   call entity_create_longplatform

   ld b, #58
   ld c, #171
   call entity_create_longplatform

   ld b, #64
   ld c, #171
   call entity_create_longplatform

   ld b, #58
   ld c, #150
   call entity_create_longplatform


    ld b, #31
    ld c, #171+6
    call entity_create_wall
    ld b, #31
    ld c, #171+6+5
    call entity_create_wall
    ld b, #31
    ld c, #171+6+5+5
    call entity_create_wall
    ld b, #31
    ld c, #171+6+5+5+5
    call entity_create_wall

    ld b, #56
    ld c, #150+6
    call entity_create_wall
    ld b, #56
    ld c, #150+6+5
    call entity_create_wall
    ld b, #56
    ld c, #150+6+5+5
    call entity_create_wall


   jp level_finish_loading
ret

load_level_caida_y_salto1:
    ld b, #1
    ld c, #30
    call entity_create_player

    call insert_tips_level8

 ;Plataforma de inicio

    ld b, #0
   ld c, #40
   call entity_create_platform



 ;Muro contiguo a la plataforma;;
    ld  b, #8
   ld c, #45
   call entity_create_longwall

    ld  b, #8
   ld c, #85
   call entity_create_longwall
   ld b, #8
   ld c, #85+40-2
   call entity_create_lid

   ;ld  b, #8
   ;ld c, #125
   ;call entity_create_longwall

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


  
 ;Muro de la derecha;;

    ld  b, #35
   ld c, #15
   call entity_create_longwall

   ld b, #30
   ld c, #15+40-2
   call entity_create_lid
   ld b , #35
   ld c , #55

   call entity_create_wall


   ld b , #35
   ld c , #60

   call entity_create_wall

   
   ld b , #35
   ld c , #65

   call entity_create_wall
   


   ld b , #35
   ld c , #70

   call entity_create_wall


   ld b , #35
   ld c , #75

   call entity_create_wall


   ld b , #35
   ld c , #80

   call entity_create_wall
   ld b, #35
   ld c, #85-2
   call entity_create_lid

  ld  b, #35
   ld c, #120
   call entity_create_longwall
  
   ld  b, #35
   ld c, #160
   call entity_create_longwall

   ld b, #35
   ld c, #120-1
   call entity_create_lid


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


    ;Plataforma 1 a la derecha del muro;;;;;;;



    ld  b, #40
    ld c, #160
   call entity_create_platform


   ld  b, #45
   ld c, #135
   call entity_create_platform







 ;;;;
     


 ;Puerta al siguiente nivel;;




    ld  b, #90
   ld c, #130
   call entity_create_platform

   ld b , #90
   ld c , #120

   call entity_create_finish


 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


   jp level_finish_loading

ret

load_level_1:
load_level_inicio:
    ld b, #1
    ld c, #100
    call entity_create_player

    ld b, #0
    ld c, #150
    call entity_create_platform

    ld b, #70
    ld c, #154
    call entity_create_platform

    ld b, #62
    ld c, #154
    call entity_create_platform


    ld  b, #70
    ld c, #161
    call entity_create_wall

   ld  b, #70
   ld c, #166
   call entity_create_wall

   ld  b, #70
   ld c, #171
   call entity_create_wall

   ld  b, #70
   ld c, #176
   call entity_create_wall

   ld  b, #70
   ld c, #181
   call entity_create_wall

   ld  b, #70
   ld c, #186
   call entity_create_wall
;
   ld  b, #70
   ld c, #191
   call entity_create_wall
    ld b, #22
   ld c, #170

   call entity_create_box



   ld b, #77
   ld c, #140
   call entity_create_finish

   jp level_finish_loading

ret

load_level_cajabolita:
    ld b, #1
    ld c, #150
    call entity_create_player

    ld b, #35
   ld c, #115
   call entity_create_doublejump

    ld  b, #32
   ld c, #169
   call entity_create_platform

    ld  b, #18
   ld c, #100
   call entity_create_platform
  

    ld b, #19
   ld c, #79
   call entity_create_finish

   

   ld b, #41
   ld c, #192

    call entity_create_spikes
     ld b, #47
   ld c, #192

   call entity_create_spikes
     ld b, #34
   ld c, #192


    call entity_create_spikes

      ld b, #74
   ld c, #192

   call entity_create_spikes

      ld b, #27
   ld c, #192

    call entity_create_spikes
   

    ld b, #60
    ld c, #170

    call entity_create_box

    ld b, #68
    ld c, #170

    call entity_create_box
    

   jp level_finish_loading
ret

load_level_zigzag:
    ld b, #39
    ld c, #182
    call entity_create_player


    ld b, #77
    ld c, #74
    call entity_create_finish

;;;;;; SEGUNDO PLATAFORMAS
    ld b, #1
    ld c, #154
    call entity_create_longplatform

     ld b, #31
    ld c, #154
    call entity_create_longplatform

    ld b, #49
    ld c, #110
    call entity_create_longplatform

    ld b, #19
    ld c, #110
    call entity_create_longplatform

;;;;;; DESPUES MUROS
;;;;;; Y POR ULTIMO CAJAS
        ld b, #1
        ld c, #186
        call entity_create_box

        ld b, #5
        ld c, #100
        call entity_create_box

     jp level_finish_loading
ret
load_level_ladder1:
    ld b, #8
    ld c, #160
    call entity_create_player

    ld b, #35
    ld c, #128
    call entity_create_horizontal_ladderlong


    ; ld b, #62
    ;ld c, #128
    ;;call entity_create_horizontal_ladder


    ld b, #75
    ld c, #160
    call entity_create_finish


    ld b, #30
    ld c, #192
    call entity_create_longspikes

    ld b, #48
    ld c, #192
    call entity_create_longspikes

    


    ;; plataforma del player
    ld b, #5
    ld c, #170
    call entity_create_longplatform
    ;plataforma del ladder
    ld b, #30
    ld c, #120
    call entity_create_longplatform
    ;; plataforma ladder
    ld b, #60
    ld c, #120
    call entity_create_platform
    ;;plataforma finish
    ld b, #68
    ld c, #170
    call entity_create_platform

  

    jp level_finish_loading
ret


load_level_deadbeef2:
    ld b, #39
    ld c, #140
    call entity_create_player

   



    ld b, #10
    ld c, #50
    call entity_create_finish

    ld b, #50
    ld c, #79
    call entity_create_spikesV

    ld b, #20
    ld c, #192
    call entity_create_longspikes

    ld b, #40
    ld c, #192
    call entity_create_longspikes

    ld b, #53
    ld c, #88
    call entity_create_doublejump

    ld b, #34
    ld c, #60
    call entity_create_doublejump
    
    ;; plataforma del finsih
    ld b, #9
    ld c, #60
    call entity_create_platform
    ;plataforma del player
    ld b, #34
    ld c, #150
    call entity_create_platform
    ;; plataforma derecha abajo
    ld b, #55
    ld c, #132
    call entity_create_platform
    ;;plataforma derecha arriba
    ld b, #50
    ld c, #72
    call entity_create_platform

    ld b, #58
    ld c, #76
    call entity_create_longwall

    jp level_finish_loading
ret

load_level_deadbeef:
    ld b, #1
    ld c, #30
    call entity_create_player

    ld b, #37
    ld c, #200
    call entity_create_finish

    jp level_finish_loading
ret


load_level_torretbolitas:
    ld b, #1
    ld c, #170
    call entity_create_player


    ld b, #78
    ld c, #147
    call entity_create_turret

    ld b, #10
    ld c, #165
    call entity_create_doublejump


    ld b, #10
    ld c, #165
    call entity_create_doublejump

    ld b, #54
    ld c, #165
    call entity_create_doublejump

   



      ld b, #22
    ld c, #194
    call entity_create_longspikes


  ld b, #40
    ld c, #194
    call entity_create_longspikes


  ld b, #48
    ld c, #194
    call entity_create_longspikes

     ld b, #54
    ld c, #194
    call entity_create_longspikes

    ld b, #30
    ld c, #165
    call entity_create_platform




    

    ld b, #20
    ld c, #200-80-1+30
    call entity_create_lid

    ld b, #20
    ld c, #200-80+30
    call entity_create_longwall

    ld b, #20
    ld c, #200-40
    call entity_create_longwall


    ld b, #20
    ld c, #200-100-40+30
    call entity_create_longwall

     ld b, #20
    ld c, #200-100-2+30
    call entity_create_lid





    ld b, #77
    ld c, #189
    call entity_create_finish

    jp level_finish_loading
ret


load_level_puente:
    ld b, #1
    ld c, #130
    call entity_create_player

    ld b, #30
    ld c, #145
    call entity_create_doublejump

    ld b, #42
    ld c, #145
    call entity_create_doublejump

    ld b, #60
    ld c, #145
    call entity_create_doublejump

    ld b, #77
    ld c, #120
    call entity_create_finish
 
    ld b, #10
    ld c, #192
    call entity_create_spikes

    ld b, #17
    ld c, #192
    call entity_create_spikes

     ld b, #24
    ld c, #192
    call entity_create_spikes

    ld b, #31
    ld c, #192
    call entity_create_spikes

     ld b, #38
    ld c, #192
    call entity_create_spikes

    ld b, #45
    ld c, #192
    call entity_create_spikes

     ld b, #52
    ld c, #192
    call entity_create_spikes

    ld b, #59
    ld c, #192
    call entity_create_spikes

     ld b, #66
    ld c, #192
    call entity_create_spikes

    ld b, #73
    ld c, #192
    call entity_create_spikes


    ld b, #0
    ld c, #140
    call entity_create_platform

    ld b, #69
    ld c, #140
    call entity_create_platform


 




    ld b, #60
    ld c, #145
    call entity_create_doublejump





 jp level_finish_loading
ret

load_level_introtorreta:
    ld b, #1
    ld c, #130-50
    call entity_create_player

    ld b, #77
    ld c, #130-40
    call entity_create_finish

    ld b, #0
    ld c, #130-20
    call entity_create_platform

    ld b, #0
    ld c, #130
    call entity_create_longplatform

    ld b, #20
    ld c, #130
    call entity_create_longplatform

    ld b, #40
    ld c, #130
    call entity_create_longplatform

    ld b, #60
    ld c, #130
    call entity_create_longplatform

    ld b, #22
    ld c, #130-6
    call entity_create_spikes

    ld b, #50
    ld c, #130-6
    call entity_create_spikes

    ld b, #30
    ld c, #130-20
    call entity_create_platform

    ld b, #78
    ld c, #130-8
    call entity_create_turret

    ld b, #30
    ld c, #200
    call entity_create_invox
    ld b, #38
    ld c, #200
    call entity_create_invox


    jp level_finish_loading
ret

load_level_pinchos:
    ld b, #1
    ld c, #185
    call entity_create_player


    ld b, #77
    ld c, #185
    call entity_create_finish
    ;; spikes de abajo
    ld b, #17
    ld c, #152
    call entity_create_spikes
    ;ld b, #28
    ;ld c, #152
    ;call entity_create_spikes

    ld b, #40
    ld c, #152
    call entity_create_spikes

    ;ld b, #52
    ;ld c, #152
    ;call entity_create_spikes

    ld b, #64
    ld c, #152
    call entity_create_spikes
    ;; spikes de arriba

    ld b, #24
    ld c, #120
    call entity_create_spikesV
    ld b, #32
    ld c, #120
    call entity_create_spikesV

    ld b, #49
    ld c, #120
    call entity_create_spikesV

    ld b, #57
    ld c, #120
    call entity_create_spikesV

  
    ;; PLATAFORMAS DE ABAJO
    ld b, #10
    ld c, #158
    call entity_create_longplatform
    ld b, #40
    ld c, #158
    call entity_create_longplatform



    ;PLATAFORMAS DE ARRIBA
     ld b, #10
    ld c, #113
    call entity_create_longplatform
    ld b, #40
    ld c, #113
    call entity_create_longplatform

    ld b, #39
    ld c, #159+6
    call entity_create_wall

    ld b, #39
    ld c, #159+6+5
    call entity_create_wall

    ld b, #39
    ld c, #170+5
    call entity_create_wall

    ld b, #39
    ld c, #175+5
    call entity_create_wall

    ld b, #39
    ld c, #180+5
    call entity_create_wall

    ld b, #39
    ld c, #185+5
    call entity_create_wall
    jp level_finish_loading
ret

load_level_apilar:
    ld b, #30
    ld c, #180
    call entity_create_player

    

    ld b, #42
    ld c, #110

    call entity_create_finish

    ld b, #38
    ld c, #140
    call entity_create_platform

    ld b, #50
    ld c, #178
    call entity_create_box

    ld b, #55
    ld c, #100
    call entity_create_box

    ld b, #6
    ld c, #100
    call entity_create_box

    ld b, #6
    ld c, #60
    call entity_create_box

    jp level_finish_loading
ret

load_level_subircoger:
    ld b, #1
    ld c, #150
    call entity_create_player

    ld b, #30
    ld c, #100
    call entity_create_doublejump 
    
    ld b, #40
    ld c, #60
    call entity_create_doublejump 

    ld b, #55
    ld c, #60
    call entity_create_doublejump 

    ld b, #50
    ld c, #100
    call entity_create_doublejump 

    ld b, #73
    ld c, #120
    call entity_create_finish

    ld b, #41
    ld c, #126
    call entity_create_longspikes

    ld b, #57
    ld c, #126
    call entity_create_spikes

    ld b, #63
    ld c, #126
    call entity_create_spikes



    ld b, #70
    ld c, #152
    call entity_create_platform  ;BASE FINISH


    ld b, #40
    ld c, #132
    call entity_create_longplatform ;BASE PINCHOS IZQUIERDA

    ld b, #25
    ld c, #165
    call entity_create_platform ;SUBIR 1

    ld b, #15
    ld c, #140
    call entity_create_platform ;SUBIR 2

    ld b, #68
    ld c, #81
    call entity_create_platform ;BASE CAJA

    ld b, #68
    ld c, #87
    call entity_create_longwall

    ld b, #75
    ld c, #20
    call entity_create_box

    
     jp level_finish_loading
ret

load_level_slalom:
    ld b, #2
    ld c, #50
    call entity_create_player

    ld b, #2
    ld c, #135
    call entity_create_finish

    ld b, #25
    ld c, #58
    call entity_create_doublejump

    ld b, #15
    ld c, #150
    call entity_create_doublejump

  ;;;; PRIMERO PINCHOS
        ld b, #17
        ld c, #89
        call entity_create_spikes

        ld b, #11
        ld c, #89
        call entity_create_spikes

        ld b, #46
        ld c, #116
        call entity_create_spikes


        ld b, #21
        ld c, #89
        call entity_create_longspikes

        ld b, #0
        ld c, #192
        call entity_create_longspikes

        ld b, #19
        ld c, #192
        call entity_create_longspikes

        ld b, #38
        ld c, #192
        call entity_create_longspikes


        ld b, #57
        ld c, #192
        call entity_create_longspikes


    

  ;;;; SEGUNDO PLATAFORMAS
    ld b, #0
    ld c, #71

    call entity_create_platform

    ld b, #42
    ld c, #120

    call entity_create_platform

  


    ld b,#10
    ld c,#93
    call entity_create_longplatform

    
  ;;;;; DESPUES MUROS
    ld b, #8
    ld c, #77

    call entity_create_longwall     ;; de 34 a 74

    ld b, #8
    ld c, #77+40-2
    call entity_create_lid


    ld b, #78
    ld c, #112
    call entity_create_turret


    jp level_finish_loading
    ret
  ;;;;; Y POR ULTIMO CAJAS


load_level_deadbeef3:
    ld b, #1
    ld c, #185
    call entity_create_player


    ld b, #77
    ld c, #185
    call entity_create_finish

    ld b, #7
    ld c, #160 
    call entity_create_doublejump


     ld b, #1
    ld c, #132
    call entity_create_doublejump


     ld b, #42
    ld c, #160
    call entity_create_doublejump


     ld b, #52
    ld c, #125
    call entity_create_doublejump









    ld b, #10
    ld c, #110
    call entity_create_platform

    ld b, #36
    ld c, #120
    call entity_create_platform

    ld b, #60
    ld c, #110
    call entity_create_platform

   

    ld b, #18
    ld c, #116
    call entity_create_longwall

    ld b, #60
    ld c, #116
    call entity_create_longwall

    

    

    ld b, #12
    ld c, #192
    call entity_create_longspikes


    ld b, #31
    ld c, #192
    call entity_create_longspikes

    ld b, #52
    ld c, #192
    call entity_create_longspikes


    ld b, #35
    ld c, #80
    call entity_create_longwall


    jp level_finish_loading
ret

load_level_cajapinchos:
    ld b, #0
    ld c, #100
    call entity_create_player

    ld b, #75
    ld c, #112
    call entity_create_finish

    ld b, #11
    ld c, #200
    call entity_create_spikes

    ld b, #17
    ld c, #200
    call entity_create_spikes

    ld b, #19
    ld c, #200
    call entity_create_spikes

    ld b, #55
    ld c, #200
    call entity_create_spikes

    ld b, #61
    ld c, #200
    call entity_create_spikes
    ld b, #63
    ld c, #200
    call entity_create_spikes

    ld b, #0
    ld c, #130
    call entity_create_longplatform

    ld b, #0
    ld c, #185
    call entity_create_platform

    ld b, #25
    ld c, #185
    call entity_create_longplatform

    ld b, #79
    ld c, #185
    call entity_create_platform

    ld b, #5
    ld c, #170
    call entity_create_box

    ld b, #35
    ld c, #140
    call entity_create_box

    ld b, #76
    ld c, #160
    call entity_create_box


    jp level_finish_loading
ret

load_level_ladder2:
    ld b, #1
    ld c, #150
    call entity_create_player

    ld b, #23
    ld c, #100
    call entity_create_doublejump

    ld b, #1
    ld c, #80
    call entity_create_finish

    ld  b, #48
    ld c, #67
    call entity_create_horizontal_ladder
   



   ld  b, #20
   ld c, #169
   call entity_create_platform

   ld  b, #42
   ld c, #139
   call entity_create_platform

   ld  b, #65
   ld c, #105
   call entity_create_platform


   ld  b, #0
   ld c, #90
   call entity_create_platform

   ld  b, #47
   ld c, #60
   call entity_create_platform
  
   ld  b, #20
   ld c, #169
   call entity_create_platform

   ld  b, #42
   ld c, #139
   call entity_create_platform

   ld  b, #67
   ld c, #105
   call entity_create_platform

   ld  b, #0
   ld c, #90
   call entity_create_platform
  
   ld  b, #47
   ld c, #60
   call entity_create_platform

   ld b, #70
   ld c, #175
   call entity_create_box

   jp level_finish_loading

ret

load_level_turretcorridor:
    ld b, #1
    ld c, #130
    call entity_create_player

    ld b, #10
    ld c, #100
    call entity_create_doublejump

    ld b, #20
    ld c, #120
    call entity_create_doublejump

    ld b, #67
    ld c, #50
    call entity_create_finish

    ld b, #77
    ld c, #70
    call entity_create_turret

    ld b, #49
    ld c, #74
    call entity_create_longplatform

    ld b, #19
    ld c, #74
    call entity_create_longplatform

    ld b, #29
    ld c, #74-16-3
    call entity_create_longplatform

    ld b, #29+30-2
    ld c, #200-40-6
    call entity_create_longplatform

    ld b, #30
    ld c, #200-50-5
    call entity_create_platform

    ld b, #29+30
    ld c, #16
    call entity_create_wall

    ld b, #29+30
    ld c, #16+5
    call entity_create_wall

    ld b, #29+30
    ld c, #16+10
    call entity_create_wall

    ld b, #29+30
    ld c, #16+15
    call entity_create_wall

    ld b, #29+30
    ld c, #16+20
    call entity_create_wall

    ld b, #29+30
    ld c, #16+25
    call entity_create_wall

    ld b, #29+30
    ld c, #16+30
    call entity_create_wall

    ld b, #29+30
    ld c, #16+35
    call entity_create_wall
    ld b, #29+30
    ld c, #16+40
    call entity_create_wall

    ld b, #29+30
    ld c, #74-16-35-5+40
    call entity_create_lid

    ld b, #29
    ld c, #199-20
    call entity_create_box

    ld b, #13
    ld c, #199-20
    call entity_create_box

    jp level_finish_loading

ret

load_level_final:
    ld b, #39
    ld c, #80
    call entity_create_player

    ld b, #18
    ld c, #200-8-30
    call entity_create_doublejump

    ld b, #5
    ld c, #200-8-30
    call entity_create_doublejump

    ld b, #2
    ld c, #200-8-30-41
    call entity_create_doublejump

    ld b, #17
    ld c, #200-8-30-50
    call entity_create_doublejump

    ld b, #0
    ld c, #200-8
    call entity_create_longspikes

    ld b, #18
    ld c, #200-8
    call entity_create_spikes

    

    ld b, #39-6
    ld c, #200-8
    call entity_create_spikes

    ld b, #39-5
    ld c, #104
    call entity_create_platform     ;Player

    ld b, #70-5
    ld c, #50+20+10
    call entity_create_platform     ;Finish

    ld b, #0
    ld c, #55
    call entity_create_platform     ;Caja #1

    ld b, #39+2
    ld c, #200-35-20-7
    call entity_create_platform
    ld b, #39+2+10
    ld c, #200-35-20-7
    call entity_create_platform

    ld b, #79
    ld c, #200-35-20-7
    call entity_create_platform

    ld b, #78
    ld c, #200-35-5
    call entity_create_longplatform

    ld b, #23
    ld c, #75
    call entity_create_doublejump

    ld b, #39
    ld c, #200-35
    call entity_create_longwall

    ld b, #39
    ld c, #200-35-35-20
    call entity_create_longwall

    ld b, #78
    ld c, #200-35-14
    call entity_create_turret

    ld b, #70
    ld c, #50
    call entity_create_finish

    ld b, #2
    ld c, #30
    call entity_create_box
    ld b, #39-4-6
    ld c, #140
    call entity_create_box
    ld b, #55
    ld c, #200-35-20
    call entity_create_box
    ld b, #75
    ld c, #187
    call entity_create_box

    call level_finish_loading
ret


load_level_heaven:
    ld b, #2
    ld c, #20
    call entity_create_player

    ld b, #30+6+3
    ld c, #200-4-15-1-60
    call entity_create_doublejump

    ld b, #30+6+3+7
    ld c, #200-4-15-1-60-30
    call entity_create_doublejump

    ld b, #30+6+3
    ld c, #200-4-15-1-60-30-30
    call entity_create_doublejump

     ld b, #65
    ld c, #120
    call entity_create_doublejump

    ld b, #60
    ld c, #160
    call entity_create_doublejump

    ld b, #39+4
    ld c, #30
    call entity_create_finish

    ld b, #30
    ld c, #200
    call entity_create_spikes

    ld b, #36+10-2+3
    ld c, #200
    call entity_create_longspikes

    ld b, #30+3+7
    ld c, #186
    call entity_create_turret

    ld b, #0
    ld c, #50
    call entity_create_platform

    ld b, #30+6
    ld c, #200-4-15-1
    call entity_create_platform

    

    ld b, #6
    ld c, #100-14
    call entity_create_longplatform

    ld b, #78
    ld c, #150
    call entity_create_platform

   

    ld b, #6+30-2+15
    ld c, #16+35+35
    call entity_create_platform

    ld b, #6+30-2
    ld c, #16+35
    call entity_create_longwall

    ld b, #6+30-2
    ld c, #14
    call entity_create_longwall

    ld b, #6+30-2+15
    ld c, #0
    call entity_create_longwall

    ld b, #6+30-2+15
    ld c, #16+35
    call entity_create_longwall

    ld b, #6+30-2+15
   ld c, #16+35-3
   call entity_create_lid

    ld b, #20
    ld c, #30
    call entity_create_box
    ld b, #50
    ld c, #30
    call entity_create_box


    jp level_finish_loading

ret
load_level_ladderturret:
    ld b, #1
    ld c, #182
    call entity_create_player

    ld b, #77
    ld c, #130
    call entity_create_finish

   
    ;;;;;; PRIMERO PINCHOS
    
        ld b, #78
    ld c, #55
    call entity_create_turret

        ld b,   #21
        ld c,   #51
        call entity_create_horizontal_ladder
        ld b,   #41
        ld c,   #51
        call entity_create_horizontal_ladder
        ld b,   #61
        ld c,   #51
        call entity_create_horizontal_ladder



 ;;;;; SEGUNDO PLATAFORMAS
        ld b,   #37
        ld c,   #168
        call entity_create_platform
        ld b,   #20
        ld c,   #132
        call entity_create_platform
        ld b,   #0
        ld c,   #97
        call entity_create_platform
        ld b,   #69
        ld c,   #140
        call entity_create_platform

        ld b , #69
        ld c, #135
        call entity_create_wall

        ld b , #69
        ld c, #130
        call entity_create_wall

        ld b , #69
        ld c, #125
        call entity_create_wall

        ld b , #69
        ld c, #120
        call entity_create_wall

        ld b , #69
        ld c, #120-1
        call entity_create_lid
        ld b,   #20
        ld c,   #43
        call entity_create_platform
        ld b,   #40
        ld c,   #43
        call entity_create_platform
        ld b,   #60
        ld c,   #43
        call entity_create_platform

 ;;;;; DESPUES MUROS

 ;;;;; Y POR ULTIMO CAJAS
        ld b, #5
        ld c, #186
        call entity_create_box
     jp level_finish_loading
ret

load_level_intropinchos:
    ld b, #2
    ld c, #180
    call entity_create_player

    ld b, #77
    ld c, #180
    call entity_create_finish

    ld b, #30
    ld c, #200
    call entity_create_longspikes

    ld b, #42
    ld c, #200
    call entity_create_longspikes

    ;ld b, #6
    ;ld c, #160-6
    ;call entity_create_spikes

    ld b, #15 
    ld c, #123-6
    call entity_create_spikes

 
    
    ld b, #33
    ld c, #123-6
    call entity_create_spikes

    ld b, #45
    ld c, #150
    call entity_create_platform

    ld b, #0
    ld c, #160
    call entity_create_platform  

    ld b, #10
    ld c, #160
    call entity_create_platform    

    ld b, #9
    ld c, #123
    call entity_create_longplatform 


    jp level_finish_loading

ret

load_level_hell:
    ld b, #77
    ld c, #200
    call entity_create_player

    ld b, #2
    ld c, #155
    call entity_create_finish

    ;Entidades efimeras

    

    ld b, #68
    ld c, #100
    call entity_create_doublejump

    ld b, #30
    ld c, #100
    call entity_create_doublejump

    ld b, #40+2
    ld c, #35+7
    call entity_create_horizontal_ladder


    ld b, #40+2+9+9
    ld c, #35+7
    call entity_create_horizontal_ladder


    ;pinchos
    ld b, #1
    ld c, #200-30-50-5
    call entity_create_longspikes

    ld b, #18+1
    ld c, #200-30-50-5
    call entity_create_longspikes

    ld b, #0
    ld c, #200
    call entity_create_longspikes

    ld b, #18
    ld c, #200
    call entity_create_longspikes

    ld b, #18+18
    ld c, #200
    call entity_create_longspikes

    ld b, #18+18+18
    ld c, #200
    call entity_create_spikes

    ld b, #18+1
    ld c, #200-30-50-5
    call entity_create_longspikes

    ld b, #18+1
    ld c, #200-30-50-5
    call entity_create_longspikes

    ld b, #18+18+1
    ld c, #200-30-50-5
    call entity_create_spikes



    ;Plataformas
    ld b, #0
    ld c, #200-30-50-20
    call entity_create_platform

    ld b, #0
    ld c, #170
    call entity_create_platform
    ld b, #7
    ld c, #170
    call entity_create_platform

    ld b, #74
    ld c, #130
    call entity_create_platform

    ld b, #40
    ld c, #35
    call entity_create_longplatform

    ld b, #40
    ld c, #170
    call entity_create_longplatform

    ld b, #74
    ld c, #70
    call entity_create_platform

    ld b, #0
    ld c, #200-30-50
    call entity_create_longplatform

    ld b, #15
    ld c, #200-30-50
    call entity_create_longplatform

    ld b, #60-10
    ld c, #120
   ; call entity_create_platform

    ;Muros
    ld b, #60
    ld c, #200-40
    call entity_create_longwall
    ld b, #60
    ld c, #200-40-40-40-1
    call entity_create_lid

    ld b, #60
    ld c, #200-40-40
    call entity_create_longwall

    ld b, #60
    ld c, #200-40-40-40
    call entity_create_longwall

    ;Cajas
    ld b, #1
    ld c, #45
    call entity_create_box

    jp level_finish_loading
ret
load_level_cajabolita2:
          ld b, #1
    ld c, #185
    call entity_create_player

    ld b, #24
    ld c, #194
    call entity_create_spikes

    ld b, #30
    ld c, #194
    call entity_create_spikes

    ld b, #38
    ld c, #194
    call entity_create_spikes

    ld b, #50
    ld c, #194
    call entity_create_longspikes

    ld b, #27
    ld c, #105
    call entity_create_doublejump

     ld b, #60
    ld c, #65
    call entity_create_doublejump






    ld b, #14
    ld c, #172
    call entity_create_platform

    ld b, #40
    ld c, #165
    call entity_create_platform

    ld b, #6
    ld c, #130
    call entity_create_platform

    ld b, #39
    ld c, #90
    call entity_create_platform

    ld b, #70
    ld c, #45
    call entity_create_platform

     ld b, #74
    ld c, #34
    call entity_create_finish

    ld b, #45
    ld c, #150
    call entity_create_box

    ld b, #45
    ld c, #148
    call entity_create_box


    jp level_finish_loading
ret

level_finish_loading:
    

    call render_init

    
    call render_estatico
    call render_change_screen
    call render_estatico
    
    call anim_init

    jp main_gameloop
ret

