.include "Physics.h.s"
.include "man/menu.h.s"
.globl obj_turret_destroy_shoot
.globl obj_turret_shoot
.globl load_next_level
.globl lifes
.globl man_gameover_init
.globl man_win_init


.globl physics_finish

.area _DATA

    physics_moved_entity:      .ds 2       ;Puntero a la entidad que se esta moviendo

    physics_jump_status:      .db #0xff    

    physics_player_last_posX: .db #0x00
    physics_player_last_posY: .db #0x00

    physics_ptr1:               .dw #0x0000
    physics_ptr2:               .dw #0x0000

    physics_last_colision::     .dw #0x0000
    physics_grabbed_box::       .dw #0x0000
    auxDW:                      .dw #0x0000
    physics_player_last_velX::   .db #0x00

    timer:        .db #5

    DoubleJumpSpriteExhausted:
    .db #0x00, #0x00
    .db #0x00, #0x00
    .db #0x10, #0x80
    .db #0x30, #0xc0
    .db #0x30, #0xc0
    .db #0x10, #0x80
    .db #0x00, #0x00
    .db #0x00, #0x00


.area _CODE

physics_update_all_entities::
    ld hl, #physics_update_one_entity
    call entity_forall

   call physics_all_colisions_try2
    call physics_move_box_with_player

ret

physics_limit_X:
    ld a, #79
    sub +8(iy)
    ld +1(iy), a
ret

physics_limit_Y:
    ld a, #199-4 ;Por el suelo, que tiene 4 de altura
    sub +9(iy)
    ld +2(iy), a

    ;La gravedad deja de afectarnos
    ld a, #0
    ld +4(iy), a

    ;Si somos el player, reset de salto
    ld a, c
    cp #1
    call z, physics_jump_reset
ret

physics_limit_upper_X:
    
    ld a , +7(iy)                        ;;Vamos a comprobar si la entidad actual es un misil para llamar al destroy del mismo
    cp #7
    call z , mark_entity_to_destroy

    ld a, #0
    ld +1(iy), a
ret

mark_entity_to_destroy::
    set 0 , (iy)                ;Marcamos el bit de componente a 1 para marcarlo y posteriormente destuirlo
ret

physics_limit_upper_Y:
    ld a, b
    ld +2(iy), a
    ld a, #0
    ld +4(iy), a
ret

physics_finish:

    ld a, #9
    ld (lifes), a
    
   call man_win_init
ret

physics_render_in_colision:
    ld a , #70
    ld (contadordepintar), a
    push ix
    push iy
    push iy
    pop de
    call render_one_entity
    call render_one_entity
    pop iy
    pop ix

ret

physics_stop_XY:

    
    ld a, (physics_player_last_posY)
    
    ld +2(ix), a
    

    call physics_jump_reset 
    

ret

physics_stop_X:

    ld a, (physics_player_last_posX)
    ld +1(ix), a
    ;ld a, (physics_player_last_posY)
    ;ld +2(ix), a
    ;inc 2(ix)
    ;ld a, 2(ix)
    ;ld (physics_player_last_posY),a

    
ret

physics_stop_Y:
    
    ld a, 7(ix)
    cp #1
    jr nz, no


    ld a, 2(ix)
    add 8(ix)
    sub 2(iy)
    jr nc, no

    ld a, (physics_player_last_posY)
    ld +2(ix), a
    call physics_jump_reset
  
    no:
    
ret

physics_stop_move_X:

    ld a, (physics_player_last_posX)
    ld +1(ix), a
    ld a, +3(ix)

    ;Comprobar si estamos a la izquierda o a la derecha
    ld a, +1(ix) ;posX player en a
    ld b, +1(iy) ;posX caja en b

    cp b ;a-b ;Si es positivo, a es mayor que b, o sea el player esta a la derecha
    jp p, mueveizquierda

    ;Si no, pues el player esta a la izquierda
    ld a, #1
    ld +3(iy), a
;
    ;add -8(iy)
    ;ld  -8(iy), a
    

ret
mueveizquierda:
    ld a, #-1
    ld +3(iy), a
ret

physics_stop_platform:
    
    ld a, +11(ix)
    ld c, a         ;En c, player

    ;Le añadimos la altura de player para que solo se active si la toca con los pies
    ld a, #4
    add c
    ld c, a


    ld a, +2(iy)    ;En a, plat
    cp c            ;Si es positivo, player es mayor
    jp m, pordebajo

    porarriba:
    jp physics_stop_move_Y

    pordebajo:
    ld a, #0
    ld +4(ix), a

    ;Colocar al player debajo de la plataforma
    ld a, +9(iy)
    ld c, a
    ld a, +2(iy)
    add c
    inc a
    
    ld c, a
    ld a, (object_grab)
    cp #0
    jr z, setplayerY

    ld a, #9
    add c ;Sumamos la caja
    ld c, a

    setplayerY:

    ld a, c
    ld +2(ix), a

    

ret

physics_stoptorreta:
    ld a, +10(ix)
    ld b, +1(iy)
    cp b
    jp m, playeralaizda


    playeraladcha:
        ld b, +1(iy)
        ld a, +8(iy)
        add b
        ld +1(ix), a

    playeralaizda:
        ld a, +1(iy)
        ld b, +8(ix)
        sub b
        ld +1(ix), a



ret

physics_stop_move_Y:

    ld a, +9(ix)
    ld c, a
    ld a, +2(iy)
    sub c ;(platformY - playerH)

    ld +2(ix), a
    ld a, #0
    ld +4(ix), a
    call physics_jump_reset
       

ret
physics_ladder:
      push ix
    push iy
    exx
    call physics_render_in_colision
    exx
    pop iy
    pop ix

    ld a, 2(iy)
    dec a
    dec a
    ld +2(ix),a
    

    call physics_jump_reset 
  


ret

maxspeed6:
    ld e, #1
ret



reset_x_speed:
  
   ld a , +7(iy)              ;Nos alojamos en a el valor del tipo de la entidad que si es un misil debe ser 7
   cp #7
   ret z
   cp #12
   ret z
   cp #1
   ret z
   ld a , #0
   ld +3(iy), a
ret

physics_doublejump_advance:
    dec a
    ld +3(iy), a
    cp #0
    call z, physics_renew_doublejump
ret

physics_updateDoublejump:
    ld a, +3(iy)
    cp #0
    call nz, physics_doublejump_advance
ret

physics_update_one_entity:: ;En de, la entidad a updatear
                            ;Rompe ix, hl, de, c

    call entity_colision ;No rompemos DE
    ; En (colision_flag), FF si colisiona y 00 si no

    call reset_x_speed
    call obj_turret_destroy_shoot

    ld a, +7(iy)
    cp #12
    call z, physics_updateDoublejump
    

    ;Ahora, si hemos colisionado, no hacemos el movimiento
    pararporcolision:
    ld a, (colision_flag)
    cp #0
    jr z, comprobarmovil

    ;Ghost en el eje X
    ld a, +7(iy)
    cp #3
    call z, physics_stop_move_X

    ;Caja en el eje Y
    ld a, +7(iy)
    cp #2
    call z, physics_stop_Y

    ;Horizontal ladder
    ld a, +7(iy)
    cp #8
    call z, physics_ladder


    ld a, +7(iy)
    cp #6
    call z, physics_stop_X

    ;Muro
    ld a, +7(iy)
    cp #10
    call z, physics_stop_X

    ;Plataforma
    ld a, +7(iy)
    cp #5
    call z, physics_stop_platform

    ;Finish
    ld a, +7(iy)
    cp #79
    
    call z, load_next_level

    ;Misil
    ld a, +7(iy)
    cp #7
    call z, physics_player_setdead

    ;Pinchos
    ld a, +7(iy)
    cp #11
    call z, physics_player_setdead

    ;Doublejump
    ld a, +7(iy)
    cp #12
    call z, physics_takeDoublejump

    ;Torreta
    ld a, +7(iy)
    cp #4
    call z, physics_stoptorreta

    

    comprobarmovil:
    ;ex de, hl
    ld c, #0
    ;Comprobamos que la entity sea móvil
    ld a, (iy)
    and a, #2 ;Componente Móvil
    cp #0
    jr z, limits

    

     ;Comprobamos si la entidad es un misil para evitar aplicarle la gravedad

    ld a , +7(iy)
    cp #7
    jr z , movlineal
    ;Comprobamos si la entity es el player o no
    
    ld de, #entity_array

    ld a, l
    cp e
    jr nz, startmoving

    ld a, h
    cp d
    jr nz, startmoving

    inc c

    startmoving:
    ;ld (physics_moved_entity), hl
    ;ld ix, (physics_moved_entity)

    ;Para el player, guardamos su posicion anterior
    ld a, c
    cp #0
    jr z, gravedad

    ld a, +1(iy)
    ld (physics_player_last_posX), a

    ld a, +2(iy)
    ld (physics_player_last_posY), a



    gravedad:

    grav:
    
        ld e, #5

        ld a, +7(iy)
        cp #2
        call z, maxspeed6 

        ld a, 4(iy)
        cp e                   ;; max speed Y
        jr z, movlineal
        inc 4(iy) ;gravedad
    


    ld hl, #physics_grabbed_box
    ld a, (hl)
    ld e, a
    cp #0
    jr z, movlineal
    inc hl
    ld a, (hl)
    ld d, a
    cp #0
    jr z, movlineal
    inc e   ;posX
    inc e   ;posY
    inc e   ;velX
    inc e   ;velY
    ld l,e
    ld h,d
    ld (hl),#0
;

    
    

    movlineal:

    ;Para hacer un avance, primero guardamos la posicion anterior 1 en la 2 y la actual en la 1
    ;ANTERIOR A SEGUNDA ANTERIOR
    ;10->12
    ld a, +10(iy)
    ld +12(iy), a
    ;11->13
    ld a, +11(iy)
    ld +13(iy), a

    ;ACTUAL A PRIMERA ANTERIOR
    ;1->10
    ld a, +1(iy)
    ld +10(iy), a
    ;2->11
    ld a, +2(iy)
    ld +11(iy), a

    ;Cambiamos la X e Y en funcion de la velocidad instantanea
    ;Primero la X...
    ld a, +1(iy) ;posX
    ld b, +3(iy) ;velX
    add a, b
    ld +1(iy), a
    
    ;... y después la Y
    ld a, +2(iy) ;posY
    ld b, +4(iy) ;velY
    add a, b
    ld +2(iy), a

    
    ;Establecemos los limites de pantalla
    ;Primero la X (limite 80)
    limits:
    
    ld a, +1(iy) ;posX
    add +8(iy)   ;width
    cp #79
    call nc, physics_limit_X

    ;...y despues la Y (limite 200)
    ld a, +2(iy)  ;posY
    add a, +9(iy) ;height
    cp #199-4 ;los 4 del suelo
    call nc, physics_limit_Y

    ;Limites superiores
    ;En X (solo funciona para velocidad 1)
    ld a, +1(iy)
    cp #0xff
    call z, physics_limit_upper_X

    ;En Y
    ld b, #16
    ld a, (object_grab)
    cp #0
    jr z, limitarupperY

    ld b, #22

    limitarupperY:
    ld a, +2(iy)
    cp b
    call c, physics_limit_upper_Y

     ;Comprobamos si la entidad es una torre para llamar a la funcion que dispara los misiles

    ld a , +7(iy)
    cp #4
    call z , obj_turret_shoot

    ghostwithbox:               ;; KEEP SAME POSITION GHOSTBOX WITH REAL BOX
    ld a, +7(iy)
    cp #3
    jr nz, coli

    ld a, +1(iy)
    ld -13(iy), a                

    ld a, +2(iy)
    dec a
    ld -12(iy), a

    ;Colisiones
    coli: 
    ;Si no es colisionable, hemos acabado
    ;ld a, (iy)
    ;and #8
    ;cp #0
    ;ret z
;
    ;;En ix, guardamos la siguiente entidad
    ;push iy
    ;pop hl
    ;ld a, (entity_data_size)
    ;ld c, a
    ;ld b, #0
    ;add hl, bc
    ;push hl
    ;pop ix
;
    ;push ix
    ;pop de
;
    ;ld hl, (entity_ptr_last)
    ;or a
    ;sbc hl, de
    ;jr z, otracosa
;
    ;colisionloop:
    ;    ld a, (ix)
    ;    and #8
    ;    cp #0
    ;    jr z, trynext
;
    ;    ;Hola, soy un puntero soltero
    ;    ;call physics_boxbox_colision_check
;
    ;    trynext:
;
    ;    push ix
    ;    pop de
;
    ;    ld hl, (entity_ptr_last)
    ;    or a
    ;    sbc hl, de
    ;    jr z, otracosa
;
    ;    ld a, (entity_data_size)
    ;    ld c, a
    ;    ld b, #0
    ;    add ix, bc
    ;jr colisionloop
;
    ;otracosa:
ret



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; JUMP ;;;;;;;;;;;;;;;;;;;;;;;;;;
physics_jump_again:
    ;flag para poder volver a saltar
    ld a, #1
    ld (flags), a
ret

physics_jump_reset: ;Rompe HL
;Parar de caer
    ld ix, #entity_array
    ld +4(ix), #0

    ;ld hl, #PlayerSprite
    ;
    ;ld a, h
    ;ld (anim_curr_sprite+1), a
;
    ;ld a, l
    ;ld (anim_curr_sprite), a

    call physics_jump_again
    
ret


physics_start_jumping:

  ld a, (flags)
  and #0x01
  cp #0
  ret z

    ;Para no poder saltar luego:
  ld a, #0
  ld (flags), a

    ;Velocidad Y negativa
  ld +4(ix), #0xF7

    ;Animacion de salto
    ld hl, #PlayerSpriteJumping
    
    ld a, l
    ld (anim_curr_sprite), a
    
    ld a, h
    ld (anim_curr_sprite+1), a

ret


physics_grab:




    
    ;ld a, (object_grab)         ;; check if have and object grabed or not
    ;cp #0
    ;jr nz, dropbox
    ;       ;; put the player as grabing something value 1
    ;ld hl, (physics_last_colision)
    ;ex de, hl
    ;call entity_colision

     ;;physics_check_in_front
    ld hl, #physics_check_in_front
    call entity_forall_but_first
    ;; if (physics grabbed box != 0)

    
     ld hl , #physics_grabbed_box
        ld a, (hl)
        cp #0
        jp z, grabjump
        ld c,a
        inc hl
        ld a,(hl)
        cp #0
        jp z, grabjump


    ld a, (object_grab)         ;; check if have and object grabed or not
    cp #1
    jr z, dropbox

    ld a, (hl)
    ld b,a 
    dec hl
    ld a, (hl)
    ld c, a
    
    ld iy, #0
    add iy, bc

    ld a, 7(iy)
    cp #3
    jr nz, next
    ;; TAKE THE BOX
    ld a, 1(ix)
    ld 1(iy), a
    ld a, 2(ix)
    sub #6
    ld 2(iy),a
    ld a, #2
    ld (iy), a
    ld a, #6
    ld -14(iy),a
    ld a, #0
    ld 4(iy),a


    ld a, #1
    ld (object_grab),a  
   

    jr grabjump
     
    dropbox:           ;; drop de box
    ld iy, (physics_grabbed_box)
    ld a, (physics_player_last_velX)        ;; will check player last direction ;; FF left, 1 right
    cp #0xff
    jr z, dropleft

        ;; DROPRIGHT
    
    ld a, 1(iy)
    add 8(ix)
    dec a
    ld 1(iy),a
    
    jr put_grab_0

    dropleft:

    ld a, 1(iy)
    sub 8(ix)
    inc a
    ld 1(iy),a



    put_grab_0:
    ld a, #0
    ld 3(iy),a                       ;same Xposition
    ld 4(iy),a 
    ld a, #10
    ld (iy), a
    ld a, #14
    ld -14(iy),a
    ld a,#0             
    ld (object_grab),a          ;; player left the object
    ld bc, #0x0000
    ld (physics_grabbed_box), bc
    ld (physics_last_colision),bc 

     next:
    grabjump:
    
   
   
ret

physics_check_in_front:

    
    ld a, (object_grab)         ;; check if have and object grabed or not
    cp #1
    jr z, finischeck

    ld hl, #entity_array
    inc hl

    ld a, (physics_player_last_velX)
    cp #1
    jr z, checkright
    ;; mov left
        dec (hl)
        dec (hl)
       
        jr docol
    checkright:
    inc (hl)         
    inc (hl)
    inc (hl)      ;; move the player to next place; +1; will check if there is a colision there, if it does, will grab that box
   
           ;; put the player as grabing something value 1

    docol:
    ;; aqui tiene que ir la caja en DE
    call entity_colision

    ld a, (colision_flag)
    cp #0xFF
    jr nz, leavecheck
        ;; HERE I HAVE COLISIONED WITH the box i am checking in that moment
        ld (physics_grabbed_box), iy 
         
        

    leavecheck:

     ld hl, #entity_array
        inc hl

        ld a, (physics_player_last_velX)
    cp #1
    jr z, uncheckright
        inc (hl)
        inc (hl)
        jr finischeck
    uncheckright:
    dec (hl)         
    dec (hl)
    dec (hl)  
;
    finischeck:
ret

;REGISTROS QUE DESTRUYO
; HL
physics_player_setdead::
    
    ld a, #1
    ld hl , #lifes                  ;;Primero comprobamos si el player ha gastado todas sus vidas
    cp (hl)
    call z , man_gameover_init      ;;Si ha perdido todas las vidas nos vamos a la pantalla de gameover
   
    dec (hl)
    call load_level                 ;;Si aun le quedan vidas le restamos una y reseteamos el nivel


ret



;physics_player_setdead:
;    call load_level
;ret
physics_player_reset::

    ld a, (ix)
    and #1
    cp #1
    jr nz, noreset
    ld (ix), #0
    call entity_create_player



    noreset:


ret

physics_move_box_with_player:
        ld a,#object_grab
        cp #0
        jr z, finishmoveboxplayer

        ld hl , #physics_grabbed_box
        ld a, (hl)
        cp #0
        jr z, finishmoveboxplayer
        ld c,a
        inc hl
        ld a,(hl)
        cp #0
        jr z, finishmoveboxplayer
        ld b,a

        ld iy, #0x0000          ;; IY GOT THE BRABBED BOX
        add iy, bc


        ld a, 7(iy)
        cp #3                           ;; check if its a box
        jr nz , finishmoveboxplayer

        ld bc, #entity_array            ;; IX GOT THE PLAYER
        ld ix,#0x0000
        add ix, bc

        ld a, 1(ix)
        ld 1(iy),a                       ;same Xposition
        ld a, 1(ix)
        ;ld (iy),a  

        ld a, 3(ix)
        ld 3(iy),a                       ;same Xposition
        ld a, 3(ix)
        ;ld -11(iy),a  


        ld a, 2(ix)             
        sub 9(iy)                       ;; substract the hight of the sprite
        dec a
        dec a                           ;; 2 times because its a ghost box that is 2 pixeles less
        ld 2(iy),a 
        ld -12(iy),a


    push ix
    push iy
    call physics_render_in_colision
    pop iy
    pop ix

    finishmoveboxplayer:
  
ret

physics_exhaust_doublejump:
    ld a, #90
    ld +3(iy), a

    ld hl, #DoubleJumpSpriteExhausted

    ld a, l
    ld +5(iy), a

    ld a, h
    ld +6(iy), a

ret

physics_renew_doublejump:

    ld hl, #DoubleJumpSpriteBig

    ld a, l
    ld +5(iy), a

    ld a, h
    ld +6(iy), a
ret

physics_takeDoublejump:
    ld a, +3(iy)
    cp #0
    ret nz

    call physics_exhaust_doublejump
    
    call physics_jump_again
ret

physics_nocollision: ;Si no ha habido colision. ix es ptr1 y iy es ptr2

ret

physics_reorganize_ghostvsghost:

    push ix
    push iy
    pop ix
    pop iy

ret

physics_ghostvsghost:

    ld a, +7(ix)
    cp #3
    ret nz
    ld a, +7(iy)
    cp #3
    ret nz

    ;Comprobamos cual esta a la derecha y cual a la izquierda
    ld a, +1(ix)
    ld b, +1(iy)
    cp b          ;a-b ;Negativo si ix esta a la izquierda de iy
    call p, physics_reorganize_ghostvsghost

    ;ix siempre es el de la izquierda, porque lo hemos reorganizado en caso contrario
    ld hl, #entity_array
    inc hl
    ld a, (hl)
    ld b, +1(iy) ;da igual cual, las dos estan juntas
    cp b            ;a-b ;Negativo si el player esta a la izquierda
    jr c, playerizda

    playerdcha:
        ld a, +1(ix)
        add +8(ix)
        ld +1(iy), a
    ret

    playerizda:
        ld a, +1(iy)
        sub +8(iy)
        ld +1(ix), a


ret 

physics_boxvsbox:
    ;ld a, #0xf0
    ;ld (#0xc005), a

    ;Solo hacemos esta funcion si ambas son cajas
    ld a, +7(ix)
    cp #2
    ret nz
    ld a, +7(iy)
    cp #2
    ret nz

    ;Solo hacemos esta funcion si una cae sobre la otra
    ld a, +2(iy)
    ld b, +2(ix)
    cp b
    ret z
    jp p, iy_arriba

    ix_arriba:

    push ix
    push iy
    pop ix
    pop iy

    iy_arriba:
    ;iy arriba, ix abajo 
    ld a, +2(iy)    ;posY de una de ellas...
    sub +9(iy)      ;...hacia arriba la altura de una...
    ld +2(ix), a    ;...nos da la posicion de "encima de la caja"
    ld +16(ix), a   ;Y repetimos la operacion para el ghost

    ;Y claro, tanto la caja como el ghost tienen que permanecer quietos
    ld a, #0
    ld +4(ix), a
    ld +18(ix), a


ret

physics_boxvsplat::
    ;Buscamos la caja
    ;CASO 1: ix ES LA CAJA
    ld a, +7(ix)
    cp #2
    jr nz, ix_no_caja
    ld a, +7(iy)
    cp #5
    ret nz ;Si no hay plataforma, nos vamos

    ;Hacemos que ix sea la plataforma e iy la caja
    push ix
    push iy
    pop ix
    pop iy
    jr boxplat_al_lio

    ;CASO 2: iy ES LA CAJA
    ix_no_caja:
    ld a, +7(iy)
    cp #2
    ret nz ;si no hay caja, nos vamos
    ld a, +7(ix)
    cp #5
    ret nz ;si no hay plataforma, nos vamos

    boxplat_al_lio: ;ix es plataforma, iy es caja, caja cae sobre plataforma

    ;Comprobamos que la caja este por encima de la plataforma
    ld a, +2(ix)
    ld b, +2(iy)
    cp b ;a-b, o sea si da positivo, ix es mayor que iy
    ret m

    ;Colocamos la caja encima
    ld a, +2(ix)    ;posY de la plataforma...
    sub +9(ix)      ;...hacia arriba su altura...
    ld +2(iy), a    ;...nos da la posicion de "encima de la plataforma"
    ld +16(iy), a   ;Y repetimos la operacion para el ghost

    ;Y claro, tanto la caja como el ghost tienen que permanecer quietos
    ld a, #0
    ld +4(iy), a
    ld +18(iy), a

ret   

physics_ghostvswall:
    ;Buscamos la caja
    ;CASO 1: ix ES LA CAJA
    ld a, +7(ix)
    cp #3
    jr nz, ix_no_ghost
    ld a, +7(iy)
    cp #10
    ret nz ;Si no hay muro, nos vamos

    ;Hacemos que ix sea el muro e iy la caja
    push ix
    push iy
    pop ix
    pop iy
    jr boxplat_al_lio

    ;CASO 2: iy ES LA CAJA
    ix_no_ghost:
    ld a, +7(iy)
    cp #3
    ret nz ;si no hay caja, nos vamos
    ld a, +7(ix)
    cp #10
    ret nz ;si no hay muro, nos vamos

    boxwall_al_lio: ;ix es muro, iy es caja, caja choca con muro

    ;Comprobamos a que lado esta la caja del muro
    ld a, +1(ix)
    ld b, +1(iy)
    cp b ;a-b, o sea si da positivo, ix es mayor que iy, caja a izquierda de muro
    jp m, box_right_of_wall

    box_left_of_wall:
    dec +1(iy)
    ret

    box_right_of_wall:
    inc +1(iy)

ret

physics_boxvsspike:
    ;CASO 1: ix ES LA CAJA
    ld a, +7(ix)
    cp #2
    jr nz, ix_no_box
    ld a, +7(iy)
    cp #11
    ret nz ;Si no hay pincho, nos vamos

    push ix
    push iy
    pop ix
    pop iy
    jr boxspike_al_lio

    ix_no_box: ;CASO 2: iy ES LA CAJA
    ld a, +7(iy)
    cp #2
    ret nz ;si no hay caja, nos vamos
    ld a, +7(ix)
    cp #11
    ret nz ;si no hay pincho, nos vamos

    boxspike_al_lio:
    
    call mark_entity_to_destroy ;destruir caja
    ld b, #0
    ld a, (entity_data_size)
    ld c, a
    add iy, bc
    call mark_entity_to_destroy ;y destruir ghost
ret


physics_collision: ;Si ha habido colision. ix es ptr1 y iy es ptr2
    
    ;Cada una de estas funciones comprueba los tipos,
    ;o sea, si los tipos no coinciden, es insta ret
    ld a, +7(ix)
    cp #8
    ret z
    ld a, +7(iy)
    cp #8
    ret z
    
    call physics_ghostvsghost
    call physics_ghostvswall
    call physics_missilevswall

    ;if( !ix_es_box && !iy_es_box ) ret;
    ld a, +7(ix)
    cp #2
    jr z, passbox

    ld a, +7(iy)
    cp #2
    jr z, passbox
    ret

    passbox:
    call physics_boxvsspike
    call physics_missilevsbox
    call physics_boxvsbox
    call physics_boxvsturret
    call physics_boxvsplat

ret

physics_boxvsturret:
    ;CASO 1: ix es la caja
    ld a, +7(ix)
    cp #2
    jr nz, ix_no_cajaT
    ld a, +7(iy)
    cp #4
    ret nz ;Si no hay torreta, nos vamos

    push ix
    push iy
    pop ix
    pop iy

    jr boxturret_al_lio

    ix_no_cajaT:
    ld a, +7(ix)
    cp #4
    ret nz ;si no hay torreta, nos vamos
    ld a, +7(iy)
    cp #2
    ret nz ;si no hay caja, nos vamos

    boxturret_al_lio:
    push ix
    push iy
    pop ix
    pop iy
    call entity_destroy

ret

physics_missilevswall:
    ;CASO 1: ix ES EL MISIL
    ld a, +7(ix)
    cp #7
    jr nz, ix_no_misilW
    ld a, +7(iy)
    cp #10
    ret nz ;Si no hay muro, nos vamos

    push ix
    push iy
    pop ix
    pop iy
    jr wallmisil_al_lio

    ix_no_misilW: ;CASO 2: iy ES EL MISIL
    ld a, +7(iy)
    cp #7
    ret nz ;si no hay misil, nos vamos
    ld a, +7(ix)
    cp #10
    ret nz ;si no hay caja, nos vamos

    wallmisil_al_lio:
    
    call mark_entity_to_destroy ;destruir misil
ret

physics_missilevsbox::
    ;CASO 1: ix ES EL MISIL
    ld a, +7(ix)
    cp #7
    jr nz, ix_no_misil
    ld a, +7(iy)
    cp #2
    ret nz ;Si no hay caja, nos vamos

    push ix
    push iy
    pop ix
    pop iy
    jr boxmisil_al_lio

    ix_no_misil: ;CASO 2: iy ES LA CAJA
    ld a, +7(iy)
    cp #7
    ret nz ;si no hay misil, nos vamos
    ld a, +7(ix)
    cp #2
    ret nz ;si no hay caja, nos vamos

    boxmisil_al_lio:
    
    call mark_entity_to_destroy ;destruir misil
ret

;Coges dos entidades, compruebas si colisionan, haces cosas en caso de que colisionen
physics_boxbox_colision_check: ;parametros, ptr1 y ptr2
    

    ld a, 1(ix)     
    add 8(ix)
    sub 1(iy)
    jp c, physics_nocollision

    ld a, 1(iy)
    add 8(iy)
    sub 1(ix)
    jp c, physics_nocollision

    ld a, 2(ix)
    add 9(ix)
    sub 2(iy)
    jp c, physics_nocollision

    ld a, 2(iy)
    add 9(iy)
    sub 2(ix)
    jp c, physics_nocollision
    
    jp physics_collision
ret
;Aunque se llame all colisions, excluye al player porque ya lo hemos 
;comprobado en update_one_entity




physics_all_colisions_try2:
    ;Objetivo: poner un objeto en ix y otro en iy e ir iterando
    ;Nos saltamos el player porque sus colisiones se hacen en otro sitio

    ;Ponemos ix en la primera
    ld ix, #entity_array

    ld b, #0
    ld a, (entity_data_size)
    ld c, a

    add ix, bc
    ;e iy en la segunda
    push ix
    pop iy
    add iy, bc

    ;Empezamos
    pac_big_loop:
        ;ix debe ser colisionable, si no lo es nos lo saltamos
        ld a, (ix)
        bit 3, a
        jr z, checkend_big


        ld a, +7(ix)
        cp #12
        jr z, checkend_big
        cp #8
        jr z, checkend_big
        cp #79
        jr z, checkend_big

        pac_little_loop:
            ;iy debe ser colisionable, si no lo es nos lo saltamos
            ld a, (iy)
            bit 3, a
            jr z, checkend_little

            ld a, (iy)
            bit 1, a
            jr z, checkend_little
            
            ;comprobamos colision entre ix e iy, y la administramos
            call physics_boxbox_colision_check

            checkend_little:
            ld bc, #entity_last
            push iy
            pop hl
            or a
            sbc hl, bc
            jr z, checkend_big

            next_iy:
            ld b, #0
            ld a, (entity_data_size)
            ld c, a
            add iy, bc
        jr pac_little_loop

        checkend_big:
        ld hl, #entity_last
        ld d, #0
        ld a, (entity_data_size)
        ld e, a
        or a
        sbc hl, de
        push ix
        pop bc
        or a
        sbc hl, bc
        ret z

        next_ix:
        ld b, #0
        ld a, (entity_data_size)
        ld c, a
        add ix, bc
        push ix
        pop iy
        add iy, bc
    jr pac_big_loop



ret